/***************************************************************************
    Kpass - Internet Password Passwortmanager
    ------------------------------------------------------------------------
    begin              : 21-2-2001
    version            : 0.012 1st release
    copyright          : (C) 2001 by Karl E. Maij
    email              : kem@sitedesign.ch
    website            : http://www.sitedesign.ch
    doc                : http://www.maij.ch/downloads/docs/kpass/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.	See http://www.gnu.org		
****************************************************************************/

#ifndef KPASS_H
#define KPASS_H

#include <qwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistbox.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qdialog.h>
#include <qclipboard.h>
#include <qdatetime.h>
#include <qmessagebox.h>
#include <qprinter.h>
#include <qpainter.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qfiledialog.h>
#include <qdir.h>
#include <qpaintdevicemetrics.h>
#include <qsimplerichtext.h>

#include <kprocess.h>
#include <kapp.h>
#include <kaction.h>
#include <klocale.h>
#include <kmenubar.h>
#include <kmessagebox.h>
#include <kstdaction.h>
#include <kconfigbase.h>
#include <kglobal.h>
#include <kconfig.h>
#include <kmainwindow.h>
#include <ksimpleconfig.h>
#include <kpassdlg.h>
#include <kservice.h>
#include <kcmdlineargs.h>

#include <kuniqueapp.h>
//#include <qarray.h>
//#include <qevent.h>
//#include <qpopupmenu.h>
//#include <qlayout.h>
//#include <qvariant.h>
#include <stdlib.h>


class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QGroupBox;
class QLabel;
class QLineEdit;
class QListBox;
class QListBoxItem;
class QMultiLineEdit;
class QPushButton;


class Kpass : public KMainWindow{

  Q_OBJECT

public:
  Kpass( KMainWindow* parent = 0, const char* name = 0, WFlags f=0 );
  ~Kpass();

	//GroupBox
  QGroupBox *groupBox;
  QLabel *lblGroup;
  QListBox *listGroup;
  QPushButton *cmdBackGroup, *cmdForwardGroup;
  QPushButton *cmdNewGroup, *cmdEditGroup, *cmdDeleteGroup;

	//PasswordBox
  QGroupBox* passwordBox;
  QLabel *lblPasswordList;
  QListBox *listPasswordList;
  QPushButton *cmdBackPassword, *cmdForwardPassword;
  QPushButton *cmdNewPassword, *cmdEditPassword, *cmdDeletePassword;

	//date created
	QLabel * lblDateCreated, * lblDate;

	//data box
  QGroupBox *dataBox;
  QLabel *lblMemo, *lblGroupDescript, *lblPassword, *lblUserName, *lblUrl;
  QLineEdit *txtUserName, *txtPassword, *txtUrl;
  QMultiLineEdit *txtMemo, *txtGroup;
  QPushButton *cmdCopyUser, *cmdCopyPassword, *cmdCopyUrl, *cmdOptions;
  QPushButton *cmdCopyGroup, *cmdOpenBrowser, *cmdCopyMemo, *cmdBackup, *cmdPrint;

	//Button Box
  QGroupBox* buttonBox;
  QPushButton* cmdQuit;

	QString getGroup() const {return listGroup->currentText();}	
	QString outPutGenerator( QString, bool, bool, bool, bool, bool, bool, bool, bool );


signals:
	void sendQuit();


public slots:
	// set the qdialog in relation to mainwindow
	//QPoint getFromMainWin();
	void appQuit();
	void getMainWinPos();
	//bool passwordCheck();

protected slots:
	// setup data to get mainWindow
	void getConfig();
	void setConfig();
	void setupMainWindow();
	void getFileDir();
	// open other dialogs
	void pwdEditMask(); // redirect to openPwdMask()
	void pwdNewMask();  // redirect to openPwdMask()
	void openPwdMask( bool );
	void openGrpMask( bool );
	void openBackup();
  void openNewGroupWin();
	void openEditGroupWin();
	void openPrinter();
	void openOptions();

	//void openLogin();
	// get the list boxes workin
	void groupSelected();
	void passwordSelected();
	void clearPasswords();
	void setGroups();
	void selectGroupDesrc();
	void passwordListDoubleClick();
	void groupListDoubleClick();
	// control buttons forward & back for listBoxes
	void forwardGroupList();
	void backGroupList();
	void forwardPasswordList();
	void backPasswordList();
	// delete functions
	void deleteGroupItem();
	void deletePasswordItem();
  // buttons on main window
	void copyPassword();
	void copyUserName();
	void copyUrl();
	void copyGroupDescr();
	void copyMemo();
	void startWebApp();
	void outPut( bool );


	//virtual void moveEvent(QMoveEvent*);

};

#endif // KPASS_H

