/***************************************************************************
    Kpass - Internet Password Passwortmanager
    ------------------------------------------------------------------------
    begin              : 21-2-2001
    version            : 0.012 1st release
    copyright          : (C) 2001 by Karl E. Maij
    email              : kem@sitedesign.ch
    website            : http://www.sitedesign.ch
    doc                : http://www.maij.ch/downloads/docs/kpass/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation.	See http://www.gnu.org		
****************************************************************************/

#ifndef KPPWD_H
#define KPPWD_H

#include <klocale.h>
#include <kconfig.h>
#include <kdialog.h>
#include <kmessagebox.h>
#include <kapp.h>

#include <qcombobox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qvariant.h>
#include <qmap.h>
#include <qfileinfo.h>
#include <qdir.h>


class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QComboBox;
class QGroupBox;
class QLabel;
class QLineEdit;
class QMultiLineEdit;
class QPushButton;


extern QString filePath;
extern int pwdGeneratorValue;

class Kppwd : public KDialog  {

	Q_OBJECT

public:
  Kppwd( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~Kppwd();

  QGroupBox *inputBox;
  QPushButton *cmdGenerator;
  QMultiLineEdit *txtMemo;
  QLineEdit *txtUserName, *txtUrl, *txtDescription, *txtPassword;
  QLabel *lblMemo, *lblGroup, *lblUserName, *lblPassword, *lblUrl, *lblDescription;
  QComboBox *comboProtocol, *comboGroup;

  QGroupBox *buttonBox;
  QPushButton *cmdSave, *cmdCancel;

 	QString getGroup() const {return comboGroup->currentText();}
 	QString getPwdDescription() const {return txtDescription->text();}
  QString getUserName() const {return txtUserName->text();}
 	QString getPassword() const {return txtPassword->text();}
 	QString getProtocol() const {return comboProtocol->currentText();}
 	QString getUrl() const {return txtUrl->text();}
 	QString getMemo() const {return txtMemo->text();}


public slots:
	void setGroup(QString textGroup);
	void setComboGroup(QString textCombo);
	void setComboGroupItem();
	void setComboProtocol(QString textCombo);
	void setComboProtocolItem();
	void setTxtPassword(QString textPassword);
	void setTxtUserName(QString textUserName);
	void setTxtUrl(QString textUrl);
	void setTxtMemo(QString textMemo);
	void setDescription(QString textDescription);
	void checkDescription();
	void pwdGenerator();


};

#endif
